package org.jboss.seam.example.selectitems;


import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import org.jboss.seam.annotations.Name;

@Entity
@Name("clientType")
public class ClientType implements Serializable {
	
	private static final long serialVersionUID = 8783761236942071493L;

	@Id @GeneratedValue
	private Integer id;
	
	private String description;
	
	@ManyToOne
	private ClientCategory clientCategory;

	public ClientType() {
	}

	public ClientCategory getClientCategory() {
		return clientCategory;
	}

	public void setClientCategory(ClientCategory clientCategory) {
		this.clientCategory = clientCategory;
	}

	public Integer getId() {
		return id;
	}
	
	public String getDescription() {
		return description;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (!(obj != null && obj instanceof ClientType))
			return false;
		ClientType ct = (ClientType) obj;
		if (this.id.equals(ct.id))
			return true;
		return false;
    }
    
    @Override
    public int hashCode() {
    	return id.hashCode();
    }
    
    @Override
	public String toString() {
		return description + "(" + id + ")";
	}

}
