package org.jboss.seam.selectitems;

import org.jboss.seam.Component;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.contexts.Contexts;

@Name("org.jboss.seam.selectitems.selectItemsConfig")
@Scope(ScopeType.EVENT)
public class SelectItemsConfig {
	
	public static final String NO_SELECTION_VALUE = "org.jboss.seam.selectitems.SelectItemsPersistenceConfig.NULL";
	
	private String persistenceUnitJndiName;
	public static final String CACHE_REGION = "org/jboss/seam/selectitems";

	public String getPersistenceUnitJndiName() {
		return persistenceUnitJndiName;
	}

	public void setPersistenceUnitJndiName(String emfJndiName) {
		this.persistenceUnitJndiName = emfJndiName;
	}
	
	 public static SelectItemsConfig instance()
	   {
	      if ( !Contexts.isEventContextActive() )
	      {
	         throw new IllegalStateException("No active application scope");
	      }
	      return (SelectItemsConfig) Component.getInstance(SelectItemsConfig.class, ScopeType.EVENT, true);
	   }

}
