package org.jboss.seam.selectitems.jsf;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;
import javax.faces.el.ValueBinding;

import org.jboss.seam.core.FacesMessages;


public class EnumConverter implements Converter {

	@SuppressWarnings("unchecked")
	public Object getAsObject(FacesContext ctx, UIComponent cmp, String value) throws ConverterException {
		ValueBinding vb = cmp.getValueBinding("value");
		if (vb == null) {
			throw new ConverterException(
					getMessage("Unable to determine enum type from value attribute"));
		}
		Class enumType = vb.getType(ctx);
		return Enum.valueOf(enumType, value);
	}

	public String getAsString(FacesContext ctx, UIComponent cmp, Object value) throws ConverterException {
		if (value == null) {
			return null;
		}
		Enum type = (Enum) value;
		return type.toString();
	}
	
	/**
	 * Utitliy method to get a FacesMessage for ConverterExceptions
	 * @param message The message to create
	 * @return The FacesMessage Object
	 */
	private FacesMessage getMessage(String message) {
		return FacesMessages.createFacesMessage(FacesMessage.SEVERITY_FATAL,
				message);
	}

}
